using System;
using System.Collections.Generic;
using System.Data;
using System.Text;

namespace CustomGridCell
{
    public class Product
    {
        public string ProductName;
        
        public string DType = "Default %";
        public string MType = "Managed %";
        
        public string dMonth;
        public string dWeek1;
        public string dWeek2;
        public string dWeek3;
        public string dWeek4;
        
        public string mMonth;
        public string mWeek1;
        public string mWeek2;
        public string mWeek3;
        public string mWeek4;

        public int rowCount = 0;


        public List<Product> childProducts = new List<Product>();

       

        public Product()
        {
            ProductName = string.Empty;

        }

        public static Product GetProductHierarchy()
        {
            Product productHierarchy = new Product();
            Product grandChildProducts = new Product(); 
            Product childProduct = new Product();
            productHierarchy.ProductName = "All Products";
            productHierarchy.DType = "Default %";
            productHierarchy.dMonth = "January";
            productHierarchy.mMonth = "February";
            productHierarchy.dWeek1 = "1";
            productHierarchy.dWeek2 = "2";
            productHierarchy.dWeek3 = "3";
            productHierarchy.dWeek4 = "4";

            productHierarchy.mWeek1 = "5";
            productHierarchy.mWeek2 = "6";
            productHierarchy.mWeek3 = "7";
            productHierarchy.mWeek4 = "8";

            for (int i = 0; i <= 10; i++)
            {
                childProduct = new Product();
                childProduct.ProductName = "Children" + i.ToString();
                childProduct.DType = "Default %";
                childProduct.dMonth = "January";
                childProduct.mMonth = "February";
                childProduct.dWeek1 = "1";
                childProduct.dWeek2 = "2";
                childProduct.dWeek3 = "3";
                childProduct.dWeek4 = "4";

                childProduct.mWeek1 = "5";
                childProduct.mWeek2 = "6";
                childProduct.mWeek3 = "7";
                childProduct.mWeek4 = "8";

                for (int j = 0; j <= 4; j++)
                {
                    grandChildProducts = new Product();
                    grandChildProducts.ProductName = "Grand Children" + j.ToString();
                    grandChildProducts.DType = "Default %";
                    grandChildProducts.dMonth = "January";
                    grandChildProducts.mMonth = "February";
                    grandChildProducts.dWeek1 = "1";
                    grandChildProducts.dWeek2 = "2";
                    grandChildProducts.dWeek3 = "3";
                    grandChildProducts.dWeek4 = "4";

                    grandChildProducts.mWeek1 = "5";
                    grandChildProducts.mWeek2 = "6";
                    grandChildProducts.mWeek3 = "7";
                    grandChildProducts.mWeek4 = "8";
                    childProduct.childProducts.Add(grandChildProducts);
                }
            
                productHierarchy.childProducts.Add(childProduct);

            }

            productHierarchy.rowCount = productHierarchy.childProducts.Count + childProduct.childProducts.Count; 
            return productHierarchy;
        }
        //public static Product GetProductHierarchy(int productId)
        //{
        //    // Adding data manually to the datatable
        //    DataTable productTable = new DataTable();
        //    productTable.Columns.Add("PRODUCT_NAME");
        //    productTable.Columns.Add("Month");
        //    productTable.Columns.Add("Week1");
        //    productTable.Columns.Add("Week2");
        //    productTable.Columns.Add("Week3");
        //    productTable.Columns.Add("Week4");

        //    // FILL THE DATATABLE 

        //    Product productHierarchy = new Product();
        //    DataRow[] row = new DataRow[10];

        //    for (int i = 0; i < 10; i++)
        //    {
        //        row[i] = productTable.NewRow();
        //        row[i]["PRODUCT_NAME"] = "Product "     + (i + 1).ToString();
        //        row[i]["Month"] =  (i + 1).ToString();
        //        row[i]["Week1"] = (i + 1).ToString();
        //        row[i]["Week2"] = (i + 1).ToString();
        //        row[i]["Week3"] =  (i + 1).ToString();
        //        row[i]["Week4"] =  (i + 1).ToString();

        //        if (i == 0)
        //        { 
        //            row[i]["PARENT_ID"] = 0;
        //        }
        //        else
        //        {
        //            row[i]["PARENT_ID"] = 1;
        //        }

        //        productTable.Rows.Add(row[i]);
        //    }

        //    int j = 0; 
        //    foreach (DataRow dataRow in productTable.Rows)
        //    {
        //        if (j == 0)
        //        {
        //            productHierarchy.ProductName = dataRow["PRODUCT_NAME"].ToString();
        //            productHierarchy.Month = dataRow["Month"].ToString();
        //            productHierarchy.Week1 = dataRow["Week1"].ToString();
        //            productHierarchy.Week2 = dataRow["Week2"].ToString();
        //            productHierarchy.Week3 = dataRow["Week3"].ToString();
        //            productHierarchy.Week4 = dataRow["Week4"].ToString();
        //        }
        //        else
        //        {
        //            Product childProduct = new Product();
        //            childProduct.ProductName = dataRow["PRODUCT_NAME"].ToString();
        //            productHierarchy.Month = dataRow["Month"].ToString();
        //            productHierarchy.Week1 = dataRow["Week1"].ToString();
        //            productHierarchy.Week2 = dataRow["Week2"].ToString();
        //            productHierarchy.Week3 = dataRow["Week3"].ToString();
        //            productHierarchy.Week4 = dataRow["Week4"].ToString();
        //            productHierarchy.childProducts.Add(childProduct);
        //        }
        //        j++;
        //    }
        //    return productHierarchy;
        //}

    }
}
